=== java/src/hdf/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
project (HDF4_JAVA_HDF C)

add_subdirectory (hdflib)
